// F18 class implementation
#include "pockethal.h"
#include "frogdefs.h"
#include "f18.h"
#include "resource.h"
#include "image.h"

	F18::F18(Blitter *blitter)
	{
		F18Data = LoadImage(IDB_F18);
		Width = F18Data->GetWidth();
		Depth = F18Data->GetHeight();
		FrameRect = new Rect();
		FrameRect->Set(0,0,99,63);

	};

	F18::~F18()
	{
		delete FrameRect;
	}

	void F18::SetFrame(int frame) {
	    FrameRect->Set(frame*100,0,frame*100+99,63);
	}

	int F18::GetXSpeed() {
		return Xmove;
	}

	int F18::GetYSpeed() {
		return Ymove;
	}

	int F18::GetXPos() {
		return Xpos;
	}

	int F18::GetYPos() {
		return Ypos;
	}

	void F18::SetPosition(int _x, int _y) {
		Xpos = _x;
		Ypos = _y;
	}


	void F18::InitF18(int _x,int _y,int _xm,int _ym, int _s, bool _on)
	{
		Xpos = _x;
		Ypos = _y;
		Refresh = _s;
		Cnt1 = Refresh;
		Xmove = _xm;
		Ymove = _ym;
		On = _on;
		Alpha = 0xFF;
	}


	void F18::SetAlpha(int alpha) {
		Alpha = alpha;
	}

	void F18::SetRefresh(int _r) {
		Refresh = _r;
	}

	void F18::SetSpeed(int _xs,int _ys) {
		Xmove = _xs;
		Ymove = _ys;
	}


	void F18::Draw(Surface *surface)
	{	
	   blitter->BlitOn(F18Data, FrameRect, surface, Xpos, Ypos, 0);//draw 1 frame 
	}

	void F18::Move(float angle)
	{
		Angle = angle;
		Cnt1--;				
		if(Cnt1 == 0)		
		{
			Xpos += Xmove;	
			Ypos += Ymove;	
			Cnt1 = Refresh;	

		}
	}



