//definition of a Sprite class for the animation demo
#include <PocketHal.h>
#include "game.h"
#include "frogdefs.h"
#include "image.h"
#include "keys.h"
#include "blitter.h"

#ifndef _FlightDemo_H_

#define _FlightDemo_H_

#define ANGLE_360	1440
#define ANGLE_90	 360
#define ANGLE_60     240
#define ANGLE_30	 120
#define ANGLE_0		   0

#define ANGULAR_INCREMENT ((float)0.25)

#define DEG_TO_RAD	((float)3.1415927/(float)180)
#define RAD_TO_DEG  ((float)180/(float)3.1415927)

#define DISP_X		240
#define DISP_Y		320

#define WORLD_X_SIZE	512
#define WORLD_Y_SIZE	512

#define FPMUL(x,y)	((((x)>>6)*((y)>>6))>>4)
#define FPDIV(x,y)	((((x)<<6)/((y)>>6))<<4)

extern void Flush_iPAQ3800(int*);

struct TDistInfo
{
       float rayLength;
       long   stepSize;
	   int   numRays;
	   int   lineThickness;
	   int   perspectiveLookup[256];
};

class FlightDemo : public Game
{
public:
  
    FlightDemo();//constructor
    virtual ~FlightDemo();//destructor

	virtual void DrawTerrain(int play_x,int play_y,int play_z,int play_ang,int play_dist, Pixel *buffer, Pixel *texture, unsigned char *height);
	virtual void InitTables();
	virtual void InitHeightMap();
	virtual bool GameInit();
	virtual void GameLoop();
	virtual void GameEnd();
	virtual void ButtonDown( int button );
	virtual void ButtonUp( int button );

private:
    Display* m_display;
	Surface* m_numbers;
    Surface* TextureData;
	Surface* HeightData;
	Surface* Hemisphere;
	
	Pixel* TextureBuffer;
	Pixel* HeightBuffer;

	Blitter *blitter;
};

#endif