//////////////////////////////////////////////////////////////////////////////
//
// PocketFrog - The Game Library for Pocket PC Devices
// Copyright 2002  Thierry Tremblay
//
// Permission to use, copy, modify, distribute and sell this software
// and its documentation for any purpose is hereby granted without fee,
// provided that the above copyright notice appear in all copies and
// that both that copyright notice and this permission notice appear
// in supporting documentation.  Thierry Tremblay makes no representations
// about the suitability of this software for any purpose.
// It is provided "as is" without express or implied warranty.
//
//////////////////////////////////////////////////////////////////////////////

#ifndef POCKETFROG_INPUT_H
#define POCKETFROG_INPUT_H

#include "defs.h"
#include "keys.h"
#include "inputdriver.h"
#include "utility.h"


//////////////////////////////////////////////////////////////////////////////
//
// InputDevice
//
//////////////////////////////////////////////////////////////////////////////

class InputDevice : NonCopyable
{
public:

    // Destruction
    ~InputDevice();

    // Convert a button key from device to logical orientation
    void DeviceToLogical( int& button ) const;


private:

    Internal::InputDriver* m_driver;
    
    // You can't create a input directly, use PocketPC::CreateInput()
    friend class PocketPC;
    InputDevice();
};



#endif
